# Below please find some examples of how to use the Direct Mail API from Python. 
# 
# Before trying these examples, please make sure and fill in your own API Key ID and Key Secret, as well as the
# Form ID. For more information on authentication and authorization, please see
# 
# https://www.directmailmac.com/support/article/349-authentication-and-authorization

import json, urllib, urllib2, base64, pprint
from urllib2 import URLError

API_KEY_ID     = 'replace-me'
API_KEY_SECRET = 'replace-me'
FORM_ID        = 'replace-me'

def execute_api_request( method, url, body = None ):
    # set up authentication
    authstring = base64.encodestring( '%s:%s' % (API_KEY_ID, API_KEY_SECRET) ).replace('\n', '')
        
    # create request object and set method by get_method hack
    request = urllib2.Request( url )
    request.add_header( "Authorization", "Basic %s" % authstring )
    request.get_method = lambda: method
    response = None
    
    if body:    
        request.add_data( json.dumps( body ) )
    
    try:
        response = urllib2.urlopen( request ).read()
    except URLError, e:
        response = json.loads( e.read() )
        print "Error %s %s: %s" % ( method, url, e.code )
    
    return response
    
# Example 1: Inserting or updating one address into your mailing list
email   = 'user@example.com'
url     = 'https://secure.directmailmac.com/api/v1/forms/' + FORM_ID + '/addresses/' + urllib.quote_plus( email ) 
body    = { "create_if_necessary" : True, 
            "address" : { "first_name" : "Mike", 
                          "last_name" : "Jones", 
                          "company_name" : "ABC Widgets, Inc.", 
                          "custom" : { "1" : "650-555-3423" } 
                        } 
          }

pprint.pprint( execute_api_request( 'PUT', url, body ) )

# Example 2: Deleting one address from your mailing list

email = 'user@example.com'
url   = 'https://secure.directmailmac.com/api/v1/forms/' + FORM_ID + '/addresses/' + urllib.quote_plus( email )

pprint.pprint( execute_api_request( 'DELETE', url ) )

# Example 3: Inserting or updating multiple addresses into your mailing list 

url     = 'https://secure.directmailmac.com/api/v1/forms/' + FORM_ID + '/addresses'
body    = { "user1@example.com" : { "create_if_necessary" : True, 
                                    "address" : { "first_name" : "Mike", 
                                                  "last_name" : "Jones",
                                                  "company_name" : "ABC Widgets, Inc.",
                                                  "custom" : { "1": "650-555-1212" }
                                                }
                                  },
            "user2@example.com" : { "create_if_necessary" : True, 
                                    "address" : { "first_name" : "Mike", 
                                                  "last_name" : "Jones",
                                                  "company_name" : "ABC Widgets, Inc.",
                                                  "custom" : { "1" : "650-555-4321" } 
                                                }
                                  },
            "user3@example.com" : { "create_if_necessary" : False, 
                                    "address" : { "first_name" : "Rod", 
                                                  "last_name" : "Green",
                                                  "email" : "user3-new@example.com",
                                                  "custom" : { "1" : None }
                                                }
                                  },
          }

pprint.pprint( execute_api_request( 'PUT', url, body ) )

# Example 4: Deleting multiple addresses from your mailing list

url     = 'https://secure.directmailmac.com/api/v1/forms/' + FORM_ID + '/addresses'
body    = ["user1@example.com", "user2@example.com", "user3@example.com"]

pprint.pprint( execute_api_request( 'DELETE', url, body ) )

# Example 5: Marking an address as unsubscribed

email   = 'user@example.com'
url     = 'https://secure.directmailmac.com/api/v1/forms/' + FORM_ID + '/addresses/' + urllib.quote_plus( email )
body    = { "create_if_necessary" : False,
            "address" : { "flags" : { "+" : "unsubscribed" } }
          }
          
pprint.pprint( execute_api_request( 'PUT', url, body ) )